<?php
/**
 * paydesign_cc_preprocess header_php.php
 *
 * @package page
 * @copyright Copyright 2003-2005 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: $
 */
  require(DIR_WS_CLASSES.'order.php');
  $order = new order;

  require(DIR_WS_CLASSES . 'order_total.php');
  $order_total_modules = new order_total;
  $order_totals = $order_total_modules->process();

  $total = round($order->info['total'], 0);
  foreach ($order_totals as $order_total) {
      if ($order_total['code'] == 'ot_total') {
          $total = round($order_total['value'], 0);
      }
  }

  $sid       = paydesign_get_new_sid();
  $fuka      = paydesign_get_fuka();
  $cc_userid = paydesign_get_cc_user_id($_SESSION['customer_id']);

  // ユーザーID使用
  if ($_SESSION['cc_user_regist'] == 2 && $cc_userid != "") {
    $url  = MODULE_PAYMENT_PAYDESIGN_CC_SETTLEEX_URL;
    $parm = array('IP'         => MODULE_PAYMENT_PAYDESIGN_CC_IP,
                  'PASS'       => MODULE_PAYMENT_PAYDESIGN_CC_PASSWORD,
                  'SID'        => $sid,
                  'IP_USER_ID' => $cc_userid,
                  'N1'         => 'ITEM'.$_SESSION['customer_id'],
                  'K1'         => $total,
                  'KAKUTEI'    => MODULE_PAYMENT_PAYDESIGN_CC_IS_AUTHORIZE_ONLY=='True'?'0':'1',
                  'FUKA'       => $fuka,
                  );
  }
  else {
    $url  = MODULE_PAYMENT_PAYDESIGN_CC_SETTLE_URL;
    $parm = array('IP'      => MODULE_PAYMENT_PAYDESIGN_CC_IP,
                  'SID'     => $sid,
                  'N1'      => 'ITEM'.$_SESSION['customer_id'],
                  'K1'      => $total,
                  'KAKUTEI' => MODULE_PAYMENT_PAYDESIGN_CC_IS_AUTHORIZE_ONLY=='True'?'0':'1',
                  'STORE'   => '51',
                  'FUKA'    => $fuka,
                  'NAME1'   => paydesign_name_convert($order->billing['firstname']),
                  'NAME2'   => paydesign_name_convert($order->billing['lastname']),
                  'KANA1'   => paydesign_name_convert($order->billing['firstname_kana']),
                  'KANA2'   => paydesign_name_convert($order->billing['lastname_kana']),
                  'TEL'     => paydesign_tel_convert($order->billing['telephone']),
                  'ADR1'    => $order->billing['state'].$order->billing['city'],
                  'ADR2'    => $order->billing['street_address'],
                  'MAIL'    => $order->customer['email_address'],
                  'YUBIN1'  => paydesign_zip_convert($order->billing['postcode']),
                  'YUBIN2'  => paydesign_zip_convert2($order->billing['postcode']),
                  );
    // ユーザーID
    if ($_SESSION['cc_user_regist'] == 1 &&
        MODULE_PAYMENT_PAYDESIGN_CC_REGIST_INFO == 'True') {
      $parm['IP_USER_ID'] = 'USERID'.$_SESSION['customer_id'];
    }
  }

  // 要求レコードの作成
  paydesign_save_request_parm($sid, 'cc', $url.'?'.paydesign_http_build_query($parm), $fuka, serialize($_SESSION));

  if ($_SESSION['cc_user_regist'] == 2 && $cc_userid != "") {
    // ユーザーID決済は即座に完了
    $options = array('http' => array(
        'method'  => 'POST',
        'content' => http_build_query($parm),
        'http'    => array('ignore_errors' => true)
    ));
    $response = file_get_contents($url, false, stream_context_create($options));
    $response = mb_convert_encoding($response, "utf8", "SJIS");
    $response = preg_replace("/\r\n|\r|\n/", "\n", $response);
    $data     = explode("\n", $response);

    // 結果確認
    if ($data[0] == "OK") {
      // 要求レコードを更新する
      // link型に合わせる
      $param = Array(
        'SID'        => $sid,
        'FUKA'       => $fuka,
        'SEQ'        => '',
        'DATE'       => date('Ymd'),
        'TIME'       => date('His'),
        'KINGAKU'    => $total,
        'CVS'        =>'',
        'IP_USER_ID' => '',
        'SCODE'      => '',
      );
      paydesign_save_response_parm($sid, 'success', serialize($param), $seq, date('Y-m-d H:i:s'));
      $_SESSION['payment'] = 'paydesign_cc';
      // この場合でも入金通知が来る
//      zen_redirect(zen_href_link(FILENAME_CHECKOUT_PROCESS, 'SID='.$sid.'&FUKA='.$fuka, 'SSL'));
      zen_redirect(zen_href_link(FILENAME_PAYDESIGN_CC_POSTPROCESS, 'SID='.$sid.'&FUKA='.$fuka, 'SSL'));
    }
    else if ($data[0] == "ERROR" ||
             $data[0] == "PRERROR") {
      require_once(DIR_WS_LANGUAGES . $_SESSION['language'] . '/modules/payment/paydesign_cc.php');
      if ($data[2] == "EXPERR") {
        $messageStack->add_session('checkout_payment', MODULE_PAYMENT_PAYDESIGN_CC_TEXT_TITLE."<br>".MODULE_PAYMENT_PAYDESIGN_CC_TEXT_EXPIRE, 'error');
      }
      else {
        $data[2] = str_replace("PRERROR", MODULE_PAYMENT_PAYDESIGN_CC_TEXT_ERROR, $data[2]);
        $data[2] = str_replace("ERROR",   MODULE_PAYMENT_PAYDESIGN_CC_TEXT_ERROR, $data[2]);
        $messageStack->add_session('checkout_payment', MODULE_PAYMENT_PAYDESIGN_CC_TEXT_TITLE."<br>".$data[2], 'error');
      }
      zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
    }
    else {
      require_once(DIR_WS_LANGUAGES . $_SESSION['language'] . '/modules/payment/paydesign_cc.php');
      $pos = strpos($http_response_header[0], '200');
      if ($pos === false) {
        // url間違いじゃないの？
        $messageStack->add_session('checkout_payment', MODULE_PAYMENT_PAYDESIGN_CC_TEXT_TITLE."<br>".MODULE_PAYMENT_PAYDESIGN_CC_TEXT_ERR_SETTLEEX_URL, 'error');
      }
      else {
        $messageStack->add_session('checkout_payment', MODULE_PAYMENT_PAYDESIGN_CC_TEXT_TITLE."<br>".MODULE_PAYMENT_PAYDESIGN_CC_TEXT_OTHER, 'error');
      }
      zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
    }
  }
  else {
    // ペイデザインへの遷移フォーム作成
    mb_http_output("pass");
    mb_internal_encoding("Shift-JIS");
    header("Content-type: text/html; charset=Shift-JIS"); 
    $html = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n"
          . '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">'."\n"
          . '  <head>'."\n"
          . '    <meta http-equiv="Content-Type" content="text/html; charset=Shift-JIS"/>'."\n"
          . '    <script language="javascript">//<!--'."\n"
          . '      function onloaded()'."\n"
          . '      {'."\n"
          . '        document.form1.submit();'."\n"
          . '      }'."\n"
          . '    //--></script>'."\n"
          . '  </head>'."\n"
          . '  <body onload="onloaded();">'."\n"
          . '    <form name="form1" id="form1" method="post" action="'.$url.'">'."\n";
    foreach ($parm as $key => $value) {
        $value = htmlspecialchars($value);
      $html .= '      <input type="hidden" name="'.$key.'" value="'.$value.'">'."\n";
    }
    $html .='      <center>ここからペイデザインの決済ページに移動します。<br>'."\n"
          . '      決済方法を変更される方は<a href="'.zen_href_link(FILENAME_CHECKOUT_PAYMENT).'">こちら</a>からお戻り下さい。<br><br>'."\n"
          . '      <center><input type="submit" value="クレジット決済を開始する"></center>'."\n"
          . '    </form>'."\n"
  //for debug
  //        . '    <a href="'.zen_href_link(FILENAME_CHECKOUT_PROCESS).'&SID='.$sid.'&FUKA='.$fuka.'">清算</a>'."\n"
          . '  </body>'."\n"
          . '</html>'."\n";
    print mb_convert_encoding($html, "Shift-JIS", "UTF-8");
    exit;
  }
?>
